//Product:	Donkey Kong HTML - Multi Screen (Nintendo) Simulator
//Version:	4.4
//Started:	27.05.2000
//Last update:	06.02.2003
//Author:		Andrzej Czyz (andrzej.czyz@blindfold.z.pl)
//Website:	www.blindfold.z.pl
//Original:	Nintendo Co. Ltd




var loaded=false;

var barrels = new MakeArray (27);
var barrelsPause = false;
var barrelsRandom; // random at init
var barrelsSpeed;
var barrelsID;	//ID for timeout

var segments = new MakeArray (5);
var segmentsPause = false;
var segmentsRandom = 4;
var segmentsSpeed;
var segmentsID;	// ID for timeout

var kong = 2;
var kongThrow = false;
var kongPause = false;
var kongRandom; //0 1 2
var kongSpeed;
var kongID; // ID for timeout

var hook;
var hookSpeed;
var hookSpeedMario;
var hookID; // ID for timeout
var hookMarioID; // ID for timeout

var mario;
var marioJump = false;
var marioSpeedJump;
var marioSpeedFall;
var marioSpeedKill;
var marioTime; // time to go mario
var marioKill = false; // if mario was killed
var marioKillPlace; // where mario was killed....
var marioTimeID; // ID for timeout
var marioJumpID; // ID for timeout
var marioFallID; // ID for timeout
var marioKillID; // ID for timeout

var score=0;
var scoreSpeed;
var scoreID; // ID for timeout
var loveSpeed;
var loveID;

var infoPos=0;
var infoMsg="";
var infoID;

var hi = new MakeArray (10);

var chars = new MakeArray (26);
chars[1]="a";
chars[2]="b";
chars[3]="c";
chars[4]="d";
chars[5]="e";
chars[6]="f";
chars[7]="g";
chars[8]="h";
chars[9]="i";
chars[10]="j";
chars[11]="k";
chars[12]="l";
chars[13]="m";
chars[14]="n";
chars[15]="o";
chars[16]="p";
chars[17]="q";
chars[18]="r";
chars[19]="s";
chars[20]="t";
chars[21]="u";
chars[22]="v";
chars[23]="w";
chars[24]="x";
chars[25]="y";
chars[26]="z";

var name='';
var nameID;
var nameFlash=false;

var keys;
var keysID;
var keysFlash=false;


var bonus=0;
var hold;
var life;
var game = 4; // 0-no game-all pictures; 1-gameA; 2-gameB; 3-game over; 4-clock; 5-set alarm; 6-high score; 7-keys
var timeID; // ID for timeout

var alarm=false;
var alarmID; // ID for timeout
var alarmOffID; // ID for timeout

var prefSound=false; // 1-on; 0-off
var prefBlur=true; // 1-on; 0-off
var prefAlarmMin=0;
var prefAlarmHour=0;

var keyUp=false;
var keyDown=false;
var keyLeft=false;
var keyRight=false;
var keyJump=false;

var codeUp = 119;
var codeDown = 115;
var codeLeft = 97;
var codeRight = 100;
var codeJump = 32;
var codeGameA = 49;
var codeGameB = 50;
var codeCurrent = 0;

//-------------------------------------------

function PicShow(id, name) {
	document.images[id].src = name;
}

// this function preloads images
function PicPreload () {

	nullPre = new Image();
	nullPre.src = "gfx/null.gif";

	barPre = new Array();
	for ( i=1 ; i<28 ; i++) {
		barPre[i] = new Image();
		barPre[i].src = "gfx/bar"+eval(i)+".gif";
	}

	hookPre = new Array();
	for ( i=1 ; i<9 ; i++) {
		hookPre[i] = new Image();
		hookPre[i].src = "gfx/hook"+eval(i)+".gif";
	}

	segPre = new Array();
	for ( i=1 ; i<6 ; i++) {
		segPre[i] = new Image();
		segPre[i].src = "gfx/seg"+eval(i)+".gif";
	}

	lifePre = new Image();
	lifePre.src = "gfx/life.gif";

	holPre = new Array();
	for ( i=1 ; i<5 ; i++) {
		holPre[i] = new Image();
		holPre[i].src = "gfx/hol"+eval(i)+".gif";
	}

	lovePre = new Array();
	for ( i=1 ; i<3 ; i++) {
		lovePre[i] = new Image();
		lovePre[i].src = "gfx/love"+eval(i)+".gif";
	}

	donkeyPre = new Array();
	for ( i=1 ; i<3 ; i++) {
		donkeyPre[i] = new Image();
		donkeyPre[i].src = "gfx/donkey"+eval(i)+".gif";
	}

	gamePre = new Array();
	for ( i=1 ; i<3 ; i++) {
		gamePre[i] = new Image();
		gamePre[i].src = "gfx/game"+eval(i)+".gif";
	}

	dayamPre = new Image();
	dayamPre.src = "gfx/dayam.gif";
	daypmPre = new Image();
	daypmPre.src = "gfx/daypm.gif";

	bridgeupPre = new Array();
	for ( i=1 ; i<4 ; i++) {
		bridgeupPre[i] = new Image();
		bridgeupPre[i].src = "gfx/bridgeup"+eval(i)+".gif";
	}

	bridgedownPre = new Array();
	for ( i=1 ; i<4 ; i++) {
		bridgedownPre[i] = new Image();
		bridgedownPre[i].src = "gfx/bridgedown"+eval(i)+".gif";
	}

	kongwalkPre = new Array();
	for ( i=1 ; i<5 ; i++) {
		kongwalkPre[i] = new Image();
		kongwalkPre[i].src = "gfx/kongwalk"+eval(i)+".gif";
	}

	kongallPre = new Array();
	for ( i=1 ; i<4 ; i++) {
		kongallPre[i] = new Image();
		kongallPre[i].src = "gfx/kongall"+eval(i)+".gif";
	}

	kongthrowPre = new Array();
	for ( i=1 ; i<4 ; i++) {
		kongthrowPre[i] = new Image();
		kongthrowPre[i].src = "gfx/kongthrow"+eval(i)+".gif";
	}

	numPre = new Array(); // czy od zera???
	for ( i=1 ; i<11 ; i++) {
		numPre[i] = new Image();
		numPre[i].src = "gfx/num"+eval(i-1)+".gif";
	}

	colonPre = new Image();
	colonPre.src = "gfx/colon.gif";

	leveronPre = new Image();
	leveronPre.src = "gfx/leveron.gif";

	leveroffPre = new Image();
	leveroffPre.src = "gfx/leveroff.gif";

	leverallPre = new Image();
	leverallPre.src = "gfx/leverall.gif";

	marioPre = new Array();
	for ( i=1 ; i<22 ; i++) {
		marioPre[i] = new Image();
		marioPre[i].src = "gfx/mario"+eval(i)+".gif";
	}

	// sory for such a waste, better idea next time
	marjumpPre = new Array();
	marjumpPre[1] = new Image();
	marjumpPre[1].src = "gfx/marjump1.gif";
	marjumpPre[4] = new Image();
	marjumpPre[4].src = "gfx/marjump4.gif";
	marjumpPre[7] = new Image();
	marjumpPre[7].src = "gfx/marjump7.gif";
	marjumpPre[8] = new Image();
	marjumpPre[8].src = "gfx/marjump8.gif";

	marleveronPre = new Image();
	marleveronPre.src = "gfx/marleveron.gif";

	marleverallPre = new Image();
	marleverallPre.src = "gfx/marleverall.gif";

	MainLoaded ();
}

// make an array
function MakeArray(size) {
	this.length = size;
	for( var i=1; i<=size; i++ ) this[i]= 0;
}

// play sound wav if sound is on
function playsound(soundtoplay) {
	if (prefSound) {
		if (navigator.appName=="Netscape" 
			&& navigator.javaEnabled()
			&& navigator.mimeTypes['audio/x-wav']
			&& self.document.nssound.IsReady() ) {
				self.document.nssound.play()
		} else {
			document.all['iesound'].src = soundtoplay
		}
	}
}

// swich sound on/off; dont preload here
function PrefSound () {
	prefSound=!prefSound;
	if (prefSound) document.images["Sound"].src = "gfx/buton.gif";
	else document.images["Sound"].src = "gfx/butoff.gif";
	playsound('sfx/jump.wav');
}

// swich blur on/off; dont preload here
function PrefBlur () {
	prefBlur=!prefBlur;
	if (prefBlur) {
		document.images["Blur"].src = "gfx/buton.gif";
		document.images["BackU"].src = "gfx/backublur.gif";
		document.images["BackD"].src = "gfx/backdblur.gif";
	} else {
		document.images["Blur"].src = "gfx/butoff.gif";
		document.images["BackU"].src = "gfx/backu.gif";
		document.images["BackD"].src = "gfx/backd.gif";
	}
	playsound('sfx/jump.wav');
}

function PrefsLoad () {
	var tmp;

	tmp=getCookie("sound");
	if (tmp == null) prefSound = true;
	else if (tmp == 1) prefSound = true;
		else prefSound = false;
	if (prefSound) document.images["Sound"].src = "gfx/buton.gif";
	else document.images["Sound"].src = "gfx/butoff.gif";

	tmp=getCookie("blur");
	if (tmp == null) prefBlur = true;
	else if (tmp == 1) prefBlur = true;
		else prefBlur = false;
	if (prefBlur) {
		document.images["Blur"].src = "gfx/buton.gif";
		document.images["BackU"].src = "gfx/backublur.gif";
		document.images["BackD"].src = "gfx/backdblur.gif";
	} else {
		document.images["Blur"].src = "gfx/butoff.gif";
		document.images["BackU"].src = "gfx/backu.gif";
		document.images["BackD"].src = "gfx/backd.gif";
	}

	for (var i=1;i<10 ;i++ ){
		tmp=getCookie("hi"+eval(i));
		if (tmp==null) hi[i]="...0000";
		else hi[i]=tmp;
	}

	tmp = getCookie("alarmH");
	if (tmp == null) prefAlarmHour = 0;
	else prefAlarmHour = parseInt(tmp);

	tmp = getCookie("alarmM");
	if (tmp == null) prefAlarmMin = 0;
	else prefAlarmMin = parseInt(tmp);

}

function PrefsSave () {
	var today = new Date();
	var expiry = new Date(today.getTime() + 28 * 24 * 60 * 60 * 1000);

	if (prefSound) setCookie("sound","1", expiry);
	else setCookie("sound","0", expiry);

	if (prefBlur) setCookie("blur","1", expiry);
	else setCookie("blur","0", expiry);

	for (var i=1;i<10 ;i++ ) setCookie("hi"+eval(i), hi[i], expiry);

	setCookie("alarmH", prefAlarmHour, expiry);
	setCookie("alarmM", prefAlarmMin, expiry);
}
/*
function AlarmSave () {
	var today = new Date();
	var expiry = new Date(today.getTime() + 28 * 24 * 60 * 60 * 1000);
	setCookie("alarmH", prefAlarmHour, expiry);
	setCookie("alarmM", prefAlarmMin, expiry);
}
*/
// name - name of the cookie
// value - value of the cookie
// [expires] - expiration date of the cookie (defaults to end of current session)
// [path] - path for which the cookie is valid (defaults to path of calling document)
// [domain] - domain for which the cookie is valid (defaults to domain of calling document)
// [secure] - Boolean value indicating if the cookie transmission requires a secure transmission
// * an argument defaults when it is assigned null as a placeholder
// * a null placeholder is not required for trailing omitted arguments
function setCookie(name, value, expires, path, domain, secure) {
  var curCookie = name + "=" + escape(value) +
      ((expires) ? "; expires=" + expires.toGMTString() : "") +
      ((path) ? "; path=" + path : "") +
      ((domain) ? "; domain=" + domain : "") +
      ((secure) ? "; secure" : "");
  document.cookie = curCookie;
}

// name - name of the desired cookie
// * return string containing value of specified cookie or null if cookie does not exist
function getCookie(name) {
  var dc = document.cookie;
  var prefix = name + "=";
  var begin = dc.indexOf("; " + prefix);
  if (begin == -1) {
    begin = dc.indexOf(prefix);
    if (begin != 0) return null;
  } else
    begin += 2;
  var end = document.cookie.indexOf(";", begin);
  if (end == -1)
    end = dc.length;
  return unescape(dc.substring(begin + prefix.length, end));
}

// keyboard control
document.onkeypress=KeyPressed;
document.onkeyup=KeyUnPressed;

function KeyPressed() {
	codeCurrent=event.keyCode;
	if (document.all&&event.keyCode == codeRight) 
		if (!keyRight) { // Right
			keyRight = true;
			MarioButtonRight();
		}
	if (document.all&&event.keyCode == codeLeft)
		if (!keyLeft) { // Left
			keyLeft = true;
			MarioButtonLeft();
		}
	if (document.all&&event.keyCode == codeUp)
		if (!keyUp) { // Up
			keyUp = true;
			MarioButtonUp();
		}
	if (document.all&&event.keyCode == codeDown)
		if (!keyDown) { // Down
			keyDown = true;
			MarioButtonDown();
		}
	if (document.all&&event.keyCode == codeJump)
		if (!keyUp) { // Jump
			keyUp = true;
			MarioButtonJump();
	}
	if ((game!=6)&&(game!=7)){
		if (document.all&&event.keyCode == codeGameA) {
			MainGameA(); // GameA
		}
		if (document.all&&event.keyCode == codeGameB) {
			MainGameB(); // GameB
		}
	}
	//alert(event.keyCode); // temp
}

function KeyUnPressed() {
//	if ((game==1)||(game==2)) {
		if (document.all&&event.keyCode != codeRight)	keyRight	= false; // Right;
		if (document.all&&event.keyCode != codeLeft)	keyLeft		= false; // Left;
		if (document.all&&event.keyCode != codeUp)	keyUp		= false; // Up;
		if (document.all&&event.keyCode != codeDown)	keyDown		= false; // Down;
		if (document.all&&event.keyCode != codeJump)	keyJump		= false; // Jump;
//	}
//		if (document.all&&event.keyCode==49) MainGameA(); // 1
//		if (document.all&&event.keyCode==50) MainGameB(); // 2
}

// barrels reset
function BarrelsReset () {
	for (var i=1; i<=27; i++) barrels[i] = 0;
	for (var i=0; i<barrelsRandom; i++) barrels[Math.floor(15*Math.random()+4)] = 1;
}

// barrels move; kong throw barrel init
function BarrelsMove () {
	for ( var i=1; i<21; i++ ) barrels[i]=barrels[i+1];
	if (barrels[14] == 0) barrels[14] = barrels[25];
	if (barrels[16] == 0) barrels[16] = barrels[22];
	for ( var i=22; i<24; i++ ) barrels[i]=barrels[i+1];
	for ( var i=25; i<27; i++ ) barrels[i]=barrels[i+1];
	barrels[21]=0;
	barrels[24]=0;
	barrels[27]=0;

	if (kongThrow) {
		if (kong == 1) barrels[27] = 1;
		if (kong == 2) barrels[24] = 1;
		if (kong == 3) barrels[21] = 1;
		kongThrow = false;
		PicShow("Kong"+eval(kong)+"", kongwalkPre[kong].src);
	}
}

// barrels show
function BarrelsShow () {
	for (var i=1; i<=27; i++)
		if (barrels[i] == 0)	{ PicShow("Bar"+eval(i)+"", nullPre.src) } else 
								{ PicShow("Bar"+eval(i)+"", barPre[i].src) }; //barPre[name.substring(3,5)].src
}

// barrels check collision - when barrels are moving
function BarrelsCollision () {
	for (i=2; i<7; i++) if ((barrels[i] == 1) && (mario == i-1))  BarrelsCollisionKillPoints ();
	for (i=8; i<13; i++) if ((barrels[i] == 1) && (mario == i-2))  BarrelsCollisionKillPoints ();
	if ((barrels[14] == 1) && (mario == 12))  BarrelsCollisionKillPoints ();
	if ((barrels[26] == 1) && (mario == 13))  BarrelsCollisionKillPoints ();
	if ((barrels[23] == 1) && (mario == 14))  BarrelsCollisionKillPoints ();
	if ((barrels[20] == 1) && (mario == 15))  BarrelsCollisionKillPoints ();
}

// barrels check collision - when mario is moving along
function BarrelsCollisionFront () {
	for (i=2; i<7; i++) if ((barrels[i] == 1) && (mario == i-1))  BarrelsCollisionKillPoints ();
	for (i=8; i<13; i++) if ((barrels[i] == 1) && (mario == i-2))  BarrelsCollisionKillPoints ();
}
// barrels check collision- when mario is going back
function BarrelsCollisionBack () {
	for (i=1; i<6; i++) if ((barrels[i] == 1) && (mario == i))  BarrelsCollisionKillPoints ();
	for (i=7; i<12; i++) if ((barrels[i] == 1) && (mario == i-1))  BarrelsCollisionKillPoints ();
}

// barrels check collision - when mario can get hit from falling barrel
function BarrelsCollisionUp () {
	if ((barrels[14] == 1) && (mario == 12))  BarrelsCollisionKillPoints ();
	if ((barrels[26] == 1) && (mario == 13))  BarrelsCollisionKillPoints ();
	if ((barrels[23] == 1) && (mario == 14))  BarrelsCollisionKillPoints ();
	if ((barrels[20] == 1) && (mario == 15))  BarrelsCollisionKillPoints ();
}

// barrels check if mario has jumped the barrel
function BarrelsCollisionKillPoints () {
	if (!marioJump) {
		MarioKill ();
	}
	else {
		if ( (mario==1)||(mario==4)	) ScoreAddFast (1);
		if ( (mario==7)||(mario==8) ) ScoreAddFast (2);
	}
}

// barrels go; 
function BarrelsGo () {
	if (!barrelsPause) {
		playsound('sfx/barrel.wav');
		BarrelsCollision ();
		if (!marioKill) {
			BarrelsMove ();
			BarrelsShow ();
			SpeedUp(2);
		}
	}
	barrelsID=setTimeout("BarrelsGo ()", barrelsSpeed);
}

// I assume that all speeds up the same (to barrels)
function SpeedUp (speed) {
	var max=200;
	if (barrelsSpeed>max) {
		barrelsSpeed-=speed; //if (segmentsSpeed>max) 
		segmentsSpeed-=speed; //if (kongSpeed>max) 
		marioSpeedJump=barrelsSpeed;	
	}
}

// segments reset
function SegmentsReset () {
	for (var i=1; i<=5; i++) segments[i] = 0;
}

// segments move; init first
function SegmentsMove () {
	for ( var i=1; i<5; i++ ) segments[i]=segments[i+1];
	if (game == 1) {
		if ( ((mario>5)&&(mario<12)) && (Math.floor(segmentsRandom*Math.random()) == 0) && (segments[4]==0)) segments[5]=1;
		else segments[5]=0;
	} else {
		if ((Math.floor(segmentsRandom*Math.random()) == 0) && (segments[4]==0)) segments[5]=1;
		else segments[5]=0;
	}
}

// segments show
function SegmentsShow () {
	for (var i=1; i<=5; i++)
		if (segments[i] == 0)	{ PicShow("Seg"+eval(i)+"", nullPre.src) } else 
								{ PicShow("Seg"+eval(i)+"", segPre[i].src) }; 
}

// segments check collision with mario
function SegmentsCollision () {
	if ((segments[1] == 1) && (mario == 11))  MarioKill ();
	if (marioJump) {
		if ((segments[3] == 1) && (mario == 8))  MarioKill ();
		if ((segments[4] == 1) && (mario == 7))  MarioKill ();
	}
}

// segments go; move show and repeat
function SegmentsGo (){
	if (!segmentsPause) {
		SegmentsMove ();
		SegmentsShow ();
		SegmentsCollision ();
	}
	segmentsID=setTimeout("SegmentsGo ()", segmentsSpeed);
}

// kong move; kong throw
function KongMove () {
	i=Math.floor(kongRandom*Math.random());
	if ((mario == 13) && (kong != 1)) i=2;
	if ((kong!=4)&&(!kongThrow)){
		// kong is going to throw
		if (i < 2 ) {
			if	((kong == 1)
				&&(barrels[27] == 0)
				&&(barrels[23] == 0)
				&&(barrels[18] == 0)
				){
				PicShow("Kong"+eval(kong)+"", kongthrowPre[kong].src);
				kongThrow = true;
			}
			if	((kong == 2)
				&&(barrels[24] == 0)
				&&(barrels[20] == 0)
				){
				PicShow("Kong"+eval(kong)+"", kongthrowPre[kong].src);
				kongThrow = true;
			}
			if	((kong == 3)
				&&(barrels[21] == 0)
			){
				PicShow("Kong"+eval(kong)+"", kongthrowPre[kong].src);
				kongThrow = true;
			}
		} else
		// kong is moving left
		if (i == 2) {
			if (kong != 1) {
				PicShow("Kong"+eval(kong--)+"", nullPre.src);
				PicShow("Kong"+eval(kong)+"", kongwalkPre[kong].src);
			}
		} else
		// kong is moving right
		if (i == 3) {
			if (kong != 3) {
				PicShow("Kong"+eval(kong++)+"", nullPre.src);
				PicShow("Kong"+eval(kong)+"", kongwalkPre[kong].src);
			}
		}
	}
//	alert(' Kong='+eval(kong)+' KongRnd='+eval(i)+' Throw='+eval(kongThrow));

};

// kong go
function KongGo () {
	if (!kongPause) KongMove ();
	kongID=setTimeout("KongGo ()", kongSpeed);
}

function HookMove () {
	hook++;

    if (hook == 2) {PicShow("Lever", leveronPre.src);}; else
    if (hook == 3) {PicShow("Hook6", hookPre[6].src);
                    PicShow("Hook3", nullPre.src);
                    PicShow("Hook2", hookPre[2].src)}; else
    if (hook == 5) {PicShow("Hook5", hookPre[5].src);
                    PicShow("Hook6", nullPre.src)}; else
	if (hook == 6) {
		PicShow("Hook4", hookPre[4].src);
		PicShow("Hook5", nullPre.src)
		if (mario==25) {
			mario=39;
			HookEnd ();
			PauseAll ();
			MarioHook ();
		}
	}; else
	if (hook == 7) {
		if (mario==25) {
			mario=39;
			HookEnd ();
			PauseAll ();
			MarioHook ();
		}
	}; else
	if (hook == 8) {
		PicShow("Hook5", hookPre[5].src);
		PicShow("Hook4", nullPre.src)
	}; else
    if (hook == 9) {PicShow("Hook6", hookPre[6].src);
                    PicShow("Hook5", nullPre.src)}; else
    if (hook == 10) {PicShow("Hook7", hookPre[7].src);
                    PicShow("Hook6", nullPre.src)}; else
    if (hook == 11) {PicShow("Hook8", hookPre[8].src);
                    PicShow("Hook7", nullPre.src)}; else
    if (hook == 13) {PicShow("Hook7", hookPre[7].src);
                    PicShow("Hook8", nullPre.src)}; else
    if (hook == 14) {PicShow("Hook6", hookPre[6].src);
                    PicShow("Hook7", nullPre.src)}; else
    if (hook == 15) {PicShow("Hook5", hookPre[5].src);
                     PicShow("Hook6", nullPre.src)}; else
	if (hook == 16) {
		PicShow("Hook4", hookPre[4].src);
		PicShow("Hook5", nullPre.src)
		if (mario==25) {
			mario=39;
			HookEnd ();
			PauseAll ();
			MarioHook ();
		}
	}; else
	if (hook == 17) {
		if (mario==25) {
			mario=39;
			HookEnd ();
			PauseAll ();
			MarioHook ();
		}
	}; else
    if (hook == 18) {PicShow("Hook5", hookPre[5].src);
                     PicShow("Hook4", nullPre.src)}; else
    if (hook == 19) {PicShow("Hook6", hookPre[6].src);
                     PicShow("Hook5", nullPre.src)}; else
    if (hook == 21) {PicShow("Hook3", hookPre[3].src);
                     PicShow("Hook2", nullPre.src);
                     PicShow("Hook6", nullPre.src);}; else
	if (hook == 22) {
		HookEnd ();
	}
}

function HookStart () {
	hook=1;
	HookGo ();
}

function HookEnd () {
	PicShow("Lever", leveroffPre.src);
	if ( mario == 13 ) PicShow("Mario13", marioPre[13].src);
	hook = 0; 
}

function HookGo () {
	if (hook!=0) {
		HookMove ();
		hookID=setTimeout("HookGo()", hookSpeed);
	}
}

function MarioButtonRight() {
	if ((game==1)||(game==2)) {
		if (!marioJump) {
			// falling from the edge
			if (mario==15) {
				mario=34;
				playsound('sfx/fall.wav');
				PauseAll ();
				MarioFall();
			};
			// move right on the lower platform - front
			if ((mario>0)&(mario<5)) {
				BarrelsCollisionFront ();
				if (!marioKill) {
					PicShow("Mario"+eval(mario++)+"", nullPre.src);
					PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
					playsound('sfx/step.wav');
				}
			};
			// move right on the upper platform - front - up barrels
			if ((mario>12)&(mario<15)) {
				BarrelsCollisionUp ();
				if (!marioKill) {
					PicShow("Mario"+eval(mario++)+"", nullPre.src);
					PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
					playsound('sfx/step.wav');
				}
			};
			// move right on the mid platform - back
			if ( (mario>6)&(mario<11) ) {
				BarrelsCollisionBack ();
				if (!marioKill) {
					PicShow("Mario"+eval(mario--)+"", nullPre.src);
					PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
					playsound('sfx/step.wav');
				}
			};
		}
	} else
	if (game==5) {
		prefAlarmMin++;
		if (prefAlarmMin==60) prefAlarmMin=0;
		AlarmShowNum ();
	}

}

function MarioButtonLeft() {
	if ((game==1)||(game==2)) {
		// swich on the hook
		if ( (mario==13)&(hook==0) ) {
			PicShow("Mario13", marleveronPre.src);
			HookStart ();
		}
		// move right near swich
		if (mario == 14) {
			mario--;
			PicShow("Mario14", nullPre.src);
			if (hook > 0)	PicShow("Mario13", marleveronPre.src); else
							PicShow("Mario13", marioPre[13].src);
			playsound('sfx/step.wav');
			BarrelsCollision ();
		}
		if (!marioJump) {

			// move left on the upper platform
			if ((mario>14)&&(mario<16)) {
				BarrelsCollisionUp ();
				if (!marioKill) {
					PicShow("Mario"+eval(mario--)+"", nullPre.src);
					PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
					playsound('sfx/step.wav');
				}
			}

			// move left on the lower platform
			if ((mario>1)&&(mario<6)) {
				BarrelsCollisionBack ();
				if (!marioKill) {
					PicShow("Mario"+eval(mario--)+"", nullPre.src);
					PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
					playsound('sfx/step.wav');
				}
			}

			// move left on the mid platform
			if ( (mario>5)&(mario<10) ){
				BarrelsCollisionFront ();
				if (!marioKill) {
					PicShow("Mario"+eval(mario++)+"", nullPre.src);
					PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
					playsound('sfx/step.wav');
				}
			}
		}
	} else
	if (game==5) {
		prefAlarmMin--;
		if (prefAlarmMin==-1) prefAlarmMin=59;
		AlarmShowNum ();
	}
}

function MarioButtonUp() {
	if ((game==1)||(game==2)) {
		// jump to the hook
		if (mario == 15) {
			mario = 24; 
			PicShow("Mario15", nullPre.src);
			playsound('sfx/jump.wav');
			MarioEdge();
		}
		// move up near swich
		if (mario == 12) {
			mario++;
			PicShow("Mario12", nullPre.src);
			if (hook > 0)	PicShow("Mario13", marleveronPre.src); else
							PicShow("Mario13", marioPre[13].src);
			playsound('sfx/step.wav');
			SegmentsCollision ();
		}
		// move up
		if ((mario==5)||(mario==10)||(mario==11)) {
			PicShow("Mario"+eval(mario++)+"", nullPre.src);
			PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
			playsound('sfx/step.wav');
			SegmentsCollision (); // below swich
		}
		// just jump
//		if ( (mario==1)||(mario==4)||(mario==7)||(mario==8) )
//			if ( !marioJump ) 
//				MarioJump ();
		// mario init
//		if (mario == 0) {
//			if ((game==1)||(game==2))
//				MarioUpInit ();
//		}
	} else
	if (game==5) {
		prefAlarmHour++;
		if (prefAlarmHour==24) prefAlarmHour=0;
		AlarmShowNum ();
	}
}

function MarioButtonJump() {
	if ((game==1)||(game==2)) {
		if ( !marioJump ) {
			// jump to the hook
			if (mario == 15) {
				mario = 24; 
				PicShow("Mario15", nullPre.src);
				playsound('sfx/jump.wav');
				MarioEdge();
			}
			// just jump
			if ( (mario==1)||(mario==4)||(mario==7)||(mario==8) ) {
				MarioJump ();
			}
			// mario init
			if (mario == 0) {
				MarioUpInit ();
			}
		}
	}
}

// mario init when time has come
function MarioUpInitTime() {
	if ((game==1)||(game==2)) {
		playsound('sfx/jump.wav');
		MarioInit ();
	}
}
// mario init when init pressed
function MarioUpInit() {
	clearTimeout(marioTimeID);
	MarioUpInitTime ();

}
function MarioButtonDown() {
	if ((game==1)||(game==2)) {
		if ( (mario == 6)||(mario == 11)||(mario == 12)||(mario == 13) ) {
			PicShow("Mario"+eval(mario--)+"", nullPre.src);
			PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
			playsound('sfx/step.wav');
			SegmentsCollision ();
		}
	} else
	if (game==5) {
		prefAlarmHour--;
		if (prefAlarmHour==-1) prefAlarmHour=23;
		AlarmShowNum ();
	}
}

function MarioJump () {
	PicShow("Mario"+eval(mario)+"", nullPre.src);
	PicShow("MarJump"+eval(mario)+"", marjumpPre[mario].src);
	marioJump = true;
	playsound('sfx/jump.wav');
	SegmentsCollision ();
	// jesli nie kolizja to skacz
	marioJumpID=setTimeout("MarioJumpDown()", marioSpeedJump);
}

function MarioJumpDown () {
	if (!marioKill) {
		marioJump = false;
		PicShow("MarJump"+eval(mario)+"", nullPre.src);
		PicShow("Mario"+eval(mario)+"", marioPre[mario].src);
	}
}

function MarioFall () {
	mario++;
	if (mario == 35) {
		PicShow("Mario20", marioPre[20].src);
		PicShow("Mario15", nullPre.src)
	} else
	if (mario == 36) {
		playsound('sfx/hit.wav');
		PicShow("Mario21", marioPre[21].src);
		PicShow("Mario20", nullPre.src)
	} else
	if (mario == 37) {
		PicShow("Mario21", nullPre.src);
	}
	if (mario < 39) marioFallID=setTimeout ( "MarioFall ()", marioSpeedFall );
	else MarioLifeLost ();
}

// mario is jumping to the hook; check if he reaches; at start mario=24
function MarioEdge () {
	if ( mario == 24 ) {
		PicShow("Mario16", marioPre[16].src);
		if ( (hook==7)||(hook==8)||(hook==17)||(hook==18) ) {
			mario=39;
			HookEnd ();
			PauseAll ();
			MarioHook ();
		} else {
			mario++;
			marioJumpID=setTimeout("MarioEdge()", marioSpeedJump);
		}
	} else
		if ( mario == 25 ) {
			PicShow("Mario16", nullPre.src);
			mario = 34;
			playsound('sfx/fall.wav');
			PauseAll ();
			MarioFall();
		}
}

function MarioHook() {
	mario++;
	if (mario == 40) {	PicShow("Mario16", marioPre[16].src);
						PicShow("Hook4", hookPre[4].src);
						PicShow("Hook2", hookPre[2].src)
	} else
	if (mario == 41) {	PicShow("Mario17", marioPre[17].src);
						PicShow("Hook6", hookPre[6].src);
						PicShow("Hook2", hookPre[2].src);
						PicShow("Hook4", nullPre.src);
						PicShow("Mario16", nullPre.src)
						playsound('sfx/step.wav');
	} else
	if (mario == 42) {	PicShow("Mario18", marioPre[18].src);
						PicShow("Hook1", hookPre[1].src);
						PicShow("Hook2", nullPre.src);
						PicShow("Hook6", nullPre.src);
						PicShow("Mario17", nullPre.src);
						PicShow("Hol"+eval(hold)+"", nullPre.src); 
						playsound('sfx/step.wav');
	} else
	if (mario == 43) {
		ScoreAddCount(20);
		hold--;
		if (hold != 0) mario = 96;

	}

	// bridge dissaperas...
	if (mario == 47) {	PicShow("BridgeUp1", nullPre.src);
						PicShow("BridgeUp2", nullPre.src);
						PicShow("BridgeUp3", nullPre.src);
	} else
	if (mario == 48) {	PicShow("BridgeUp1", bridgeupPre[1].src);
						PicShow("BridgeUp2", bridgeupPre[2].src);
						PicShow("BridgeUp3", bridgeupPre[3].src);
	} else
	if (mario == 49) {	PicShow("BridgeUp1", nullPre.src);
						PicShow("BridgeUp2", nullPre.src);
						PicShow("BridgeUp3", nullPre.src);
	} else
	if (mario == 50) {	PicShow("BridgeUp1", bridgeupPre[1].src);
						PicShow("BridgeUp2", bridgeupPre[2].src);
						PicShow("BridgeUp3", bridgeupPre[3].src);
	}	 else
	if (mario == 51) {	PicShow("BridgeUp1", nullPre.src);
						PicShow("BridgeUp2", nullPre.src);
						PicShow("BridgeUp3", nullPre.src);
	} else
	if (mario == 52) {	PicShow("BridgeUp1", bridgeupPre[1].src);
						PicShow("BridgeUp2", bridgeupPre[2].src);
						PicShow("BridgeUp3", bridgeupPre[3].src);
	} else
	if (mario == 53) {	PicShow("BridgeDown1", bridgedownPre[1].src);
						PicShow("BridgeDown2", bridgedownPre[2].src);
						PicShow("BridgeDown3", bridgedownPre[3].src);
						PicShow("BridgeUp1", nullPre.src);
						PicShow("BridgeUp2", nullPre.src);
						PicShow("BridgeUp3", nullPre.src);
						PicShow("Kong4", kongwalkPre[4].src);
						PicShow("Kong"+eval(kong)+"", nullPre.src);
						kong = 4;
						playsound('sfx/hit.wav');
	} else
	if (mario == 54) {	PicShow("BridgeDown1", nullPre.src);
						PicShow("BridgeDown2", nullPre.src);
						PicShow("BridgeDown3", nullPre.src);
	} else
	if (mario == 55) {
		ScoreAddCount(20);
		LoveGo();
		SpeedUp(-200); // actually slow down bonus
	}

	if (mario == 57) mario = 100;

	// move hook to normal
	if (mario == 101) {	PicShow("Mario17", marioPre[17].src);
						PicShow("Hook2", hookPre[2].src);
						PicShow("Hook6", hookPre[6].src);
						PicShow("Hook1", nullPre.src);
						PicShow("Mario18", nullPre.src)
						playsound('sfx/step.wav');
	} else
	if (mario == 102) {	PicShow("Mario19", marioPre[19].src);
						PicShow("Hook3", hookPre[3].src);
						PicShow("Hook2", nullPre.src);
						PicShow("Hook6", nullPre.src);
						PicShow("Mario17", nullPre.src);
						playsound('sfx/step.wav');
	} else
	// once again...
	if (mario == 103) {	PicShow("Mario19", nullPre.src);
						playsound('sfx/step.wav');

						if (kong == 4) {	PicShow("Kong1", kongwalkPre[1].src);
											PicShow("Kong4", nullPre.src);
											PicShow("BridgeUp1", bridgeupPre[1].src);
											PicShow("BridgeUp2", bridgeupPre[2].src);
											PicShow("BridgeUp3", bridgeupPre[3].src);
											PicShow("Hol1", holPre[1].src);
											PicShow("Hol2", holPre[2].src);
											PicShow("Hol3", holPre[3].src);
											PicShow("Hol4", holPre[4].src);
											kong=1;
											hold=4;
						}
	}

	if (mario < 105) hookMarioID=setTimeout("MarioHook()", hookSpeedMario); 
	else AllInit ();
}

function MarioKill () {
	PauseAll ();
	marioKillPlace = mario;
	mario = 100;
	marioKill = true;
	PauseAll ();
	playsound('sfx/hit.wav');
	if (!marioJump) MarioKillGo ();
	else MarioKillGoJump ();
}

function MarioKillGo () {
	mario++;
	if (mario == 102) {
		PicShow("Mario"+eval(marioKillPlace)+"", nullPre.src); 
		playsound('sfx/jump.wav');
	} else
	if (mario == 103) {
		PicShow("Mario"+eval(marioKillPlace)+"", marioPre[marioKillPlace].src);
		playsound('sfx/jump.wav');
	} else
	if (mario == 104) {
		PicShow("Mario"+eval(marioKillPlace)+"", nullPre.src); 
		playsound('sfx/jump.wav');
	} 
	if (mario < 108) marioKillID=setTimeout("MarioKillGo ()", marioSpeedKill);
	else MarioLifeLost();
}

function MarioKillGoJump () {
	marioJump = false;
	mario++;
	if (mario == 102) {
		PicShow("MarJump"+eval(marioKillPlace)+"", nullPre.src);
		playsound('sfx/jump.wav');
	} else
	if (mario == 103) {
		PicShow("MarJump"+eval(marioKillPlace)+"", marjumpPre[marioKillPlace].src);
		playsound('sfx/jump.wav');
	} else
	if (mario == 104) {
		PicShow("MarJump"+eval(marioKillPlace)+"", nullPre.src);
		playsound('sfx/jump.wav');		
	}
	if (mario < 108) marioKillID=setTimeout("MarioKillGoJump ()", marioSpeedKill);
	else MarioLifeLost();
}



function UnPauseAll () {
	barrelsPause = false;
	segmentsPause = false;
	kongPause = false;
}

function PauseAll () {
	barrelsPause = true;
	segmentsPause = true;
	kongPause = true;
}

// hide mario; run all; set up mario to go
function AllInit () {
	mario = 0;
	UnPauseAll ();
	marioTimeID=setTimeout("MarioTime()", marioTime);
}

// mario is going
function MarioInit () {
		mario = 1;
		PicShow("Mario1", marioPre[1].src);
		LifeShow ();
}

// set up mario to go
function MarioTime () {
	if (mario == 0) MarioUpInitTime ();
}

// mario losts his life; check for game over; reset kills; init
function MarioLifeLost () {
	if (life == 1) {
		GameOver ();
	} else {
		life--;
		SpeedUp(-200); // actually slow down
		marioKill = false;
		AllInit ();
	}
}

function GameStop () {
	clearTimeout(barrelsID);
	clearTimeout(segmentsID);
	clearTimeout(kongID);
	clearTimeout(hookID);
	clearTimeout(hookMarioID);
	clearTimeout(marioTimeID);
	clearTimeout(marioJumpID);
	clearTimeout(marioFallID);
	clearTimeout(marioKillID);
	clearTimeout(scoreID);
	clearTimeout(loveID);
	clearTimeout(timeID);
	clearTimeout(alarmOffID);
	TimeAlarmOff ();
}

function GameOver () {
	//PauseAll();
	GameStop ();
	playsound('sfx/over.wav');

	// check if I have a high score
	if (score>parseInt(hi[9].substring( hi[9].length-4, hi[9].length))) {
		game=6;
		HighScoreEdit ();
	}
	else MainGameOver();

}

function MainGameOver () {
	game=3;
	InfoTextClear ();
	InfoTextHighScores ();
	InfoTextStart ();
	InfoTextKeys ();
	InfoTextIngame ();
	InfoTextRoll ();
}

function LifeShow () {
	if ( life>1 )	PicShow("Life1", lifePre.src);
	else			PicShow("Life1", nullPre.src);
	if ( life>2 )	PicShow("Life2", lifePre.src);
	else			PicShow("Life2", nullPre.src);
	if ( life>3 )	PicShow("Life3", lifePre.src);
	else			PicShow("Life3", nullPre.src);
}

function ScoreShow () {
	if ( score>999 )	PicShow("Num1", numPre[Math.floor((score/1000))+1].src);
	else				PicShow("Num1", nullPre.src);
	if ( score>99 )		PicShow("Num2", numPre[Math.floor((score%1000/100))+1].src);
	else				PicShow("Num2", nullPre.src);
	if ( score>9 )		PicShow("Num3", numPre[Math.floor((score%100)/10)+1].src);
	else				PicShow("Num3", nullPre.src);
						PicShow("Num4", numPre[(score%10)+1].src);
}

function ScoreAddCount (points) {
	bonus=points;
	ScoreGo ();
}

function ScoreGo () {
	ScoreAddFast(1);
	bonus--;
	playsound('sfx/bonus.wav');
	if (bonus>0) scoreID=setTimeout("ScoreGo()", scoreSpeed); 
}

function ScoreAddFast (points) {
	tmpScore=score;
	score+=points;
	if (((score%1000)>=300)&&((tmpScore%1000)<300)) {
		life++;
		playsound('sfx/over.wav');
		LifeShow ();
	}
	if (score>9999) score-=10000;
	ScoreShow ();
}

function LoveGo() {
	if (bonus>0) {
		if ((bonus%4) < 2) {
			PicShow("Love1", lovePre[1].src);
			PicShow("Love2", nullPre.src);
		} else {
			PicShow("Love1", nullPre.src);
			PicShow("Love2", lovePre[2].src);
		}
		loveID=setTimeout("LoveGo()", loveSpeed); 
	}
	else {
		PicShow("Love1", nullPre.src);
		PicShow("Love2", nullPre.src);
	}
}

function MainPicturesGame() {
	PicShow("Hook3", hookPre[3].src);
	PicShow("Lever", leveroffPre.src);
	for ( i=1 ; i<=life ; i++) PicShow("Life"+eval(i)+"", lifePre.src);
	for ( i=1 ; i<4 ; i++) PicShow("BridgeUp"+eval(i)+"", bridgeupPre[i].src);
	for ( i=1 ; i<=hold ; i++) PicShow("Hol"+eval(i)+"", holPre[i].src);
	PicShow("Kong2", kongwalkPre[2].src);
	if (game==1) PicShow("Game1", gamePre[1].src);
	else if (game==2) PicShow("Game2", gamePre[2].src);
}

function MainPicturesShow () {
	for ( i=1 ; i<9 ; i++) PicShow("Hook"+eval(i)+"", hookPre[i].src);
	PicShow("Lever", leverallPre.src);
	for ( i=1 ; i<22 ; i++) PicShow("Mario"+eval(i)+"", marioPre[i].src);
	PicShow("MarJump1", marjumpPre[1].src);
	PicShow("MarJump4", marjumpPre[4].src);
	PicShow("MarJump7", marjumpPre[7].src);
	PicShow("MarJump8", marjumpPre[8].src);
	PicShow("Mario13", marleverallPre.src);
	for ( i=1 ; i<4 ; i++) PicShow("BridgeUp"+eval(i)+"", bridgeupPre[i].src);
	for ( i=1 ; i<4 ; i++) PicShow("BridgeDown"+eval(i)+"", bridgedownPre[i].src);
	for ( i=1 ; i<4 ; i++) PicShow("Kong"+eval(i)+"", kongallPre[i].src);
	PicShow("Kong4", kongwalkPre[4].src);
	for ( i=1 ; i<4 ; i++) PicShow("Life"+eval(i)+"", lifePre.src);
	for ( i=1 ; i<5 ; i++) PicShow("Hol"+eval(i)+"", holPre[i].src);
	for ( i=1 ; i<6 ; i++) PicShow("Seg"+eval(i)+"", segPre[i].src);
	for ( i=1 ; i<28 ; i++) PicShow("Bar"+eval(i)+"", barPre[i].src);
	PicShow("Colon", colonPre.src);
	for ( i=1 ; i<5 ; i++) PicShow("Num"+eval(i)+"", numPre[9].src);
	PicShow("DayAM", dayamPre.src);
	PicShow("DayPM", daypmPre.src);
	PicShow("Game1", gamePre[1].src);
	PicShow("Game2", gamePre[2].src);
	for ( i=1 ; i<3 ; i++) PicShow("Love"+eval(i)+"", lovePre[i].src);
	for ( i=1 ; i<3 ; i++) PicShow("Donkey"+eval(i)+"", donkeyPre[i].src);
}

function MainPicturesClear () {
	for ( i=1 ; i<9 ; i++) PicShow("Hook"+eval(i)+"", nullPre.src);
	PicShow("Lever", nullPre.src);
	for ( i=1 ; i<22 ; i++) PicShow("Mario"+eval(i)+"", nullPre.src);
	PicShow("MarJump1", nullPre.src);
	PicShow("MarJump4", nullPre.src);
	PicShow("MarJump7", nullPre.src);
	PicShow("MarJump8", nullPre.src);
	for ( i=1 ; i<4 ; i++) PicShow("BridgeUp"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<4 ; i++) PicShow("BridgeDown"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<5 ; i++) PicShow("Kong"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<4 ; i++) PicShow("Life"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<5 ; i++) PicShow("Hol"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<6 ; i++) PicShow("Seg"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<28 ; i++) PicShow("Bar"+eval(i)+"", nullPre.src);
	PicShow("Colon", nullPre.src);
	for ( i=1 ; i<5 ; i++) PicShow("Num"+eval(i)+"", nullPre.src);
	PicShow("DayAM", nullPre.src);
	PicShow("DayPM", nullPre.src);
	PicShow("Game1", nullPre.src);
	PicShow("Game2", nullPre.src);
	for ( i=1 ; i<3 ; i++) PicShow("Donkey"+eval(i)+"", nullPre.src);
	for ( i=1 ; i<3 ; i++) PicShow("Love"+eval(i)+"", nullPre.src);
}



function TimeShow () {
	var Digital=new Date()
	var hour=Digital.getHours()
	var min=Digital.getMinutes()
	var sec=Digital.getSeconds()

	if ((hour>=12)&&(min>=1)||(hour>=13)) { //PM
		hour-=12;
		PicShow("DayAM", nullPre.src);
		PicShow("DayPM", daypmPre.src);
	} else { //AM
		PicShow("DayAM", dayamPre.src);
		PicShow("DayPM", nullPre.src);
	}
	if (hour==0) hour=12;

	if (hour<10)	PicShow("Num1", nullPre.src);
	else			PicShow("Num1", numPre[Math.floor(hour/10)+1].src);
	PicShow("Num2", numPre[(hour%10)+1].src);
	PicShow("Num3", numPre[Math.floor(min/10)+1].src);
	PicShow("Num4", numPre[(min%10)+1].src);

//	if ((sec%2)==0) 
	PicShow("Colon", colonPre.src);
//	else PicShow("Colon", nullPre.src);

	timeID=setTimeout("TimeShow()", 1000)	
}

function AlarmShow () {
	AlarmShowNum();
	timeID=setTimeout("AlarmShow()", 1000)	
}

function AlarmShowNum () {
	var hour=prefAlarmHour;
	var min=prefAlarmMin;

	if ((hour>=12)&&(min>=1)||(hour>=13)) { //PM
		hour-=12;
		PicShow("DayAM", nullPre.src);
		PicShow("DayPM", daypmPre.src);
	} else { //AM
		PicShow("DayAM", dayamPre.src);
		PicShow("DayPM", nullPre.src);
	}
	if (hour==0) hour=12;

	if (hour<10)	PicShow("Num1", nullPre.src);
	else			PicShow("Num1", numPre[Math.floor(hour/10)+1].src);
	PicShow("Num2", numPre[(hour%10)+1].src);
	PicShow("Num3", numPre[Math.floor(min/10)+1].src);
	PicShow("Num4", numPre[(min%10)+1].src);
	PicShow("Donkey1", donkeyPre[1].src);
	PicShow("Colon", colonPre.src);
}

// check if its time for alarm
function TimeAlarm () {
	var Digital=new Date();
	var hour=Digital.getHours();
	var min=Digital.getMinutes();
	var sec=Digital.getSeconds();

	if ((hour==prefAlarmHour)&&(min==prefAlarmMin)&&(!alarm)) { // since I run this one time per minute, I dont need &&(sec==1)
		alarm=true;
		alarmOffID=setTimeout("TimeAlarmOff()", 15000);
		TimeAlarmGo ();
	}
}

// alarm rings
function TimeAlarmGo () {
	var Digital=new Date()
	var sec=Digital.getSeconds()

	if ((sec%2)==1) {
		PicShow("Donkey1", nullPre.src);
		PicShow("Donkey2", donkeyPre[2].src);
		playsound('sfx/over.wav');
	} else {
		PicShow("Donkey1", donkeyPre[1].src);
		PicShow("Donkey2", nullPre.src);
	}
	alarmID=setTimeout("TimeAlarmGo()", 1000)	;
}

// alarm off
function TimeAlarmOff () {
	clearTimeout(alarmID);
	alarm = false;
	if (game==0) {
		PicShow("Donkey1", donkeyPre[1].src);
		PicShow("Donkey2", donkeyPre[2].src);
	} else {
		PicShow("Donkey1", nullPre.src);
		PicShow("Donkey2", nullPre.src);
	}
}

// function runs all the time and checks the alarm
function TimeAlarmBackground () {
	TimeAlarm ();
	setTimeout("TimeAlarmBackground()", 60000)	;
}



// 0-no game-all pictures; 1-gameA; 2-gameB; 3-game over; 4-clock; 5-set alarm; 6-high score
// set the alarm
function MainAlarm () {
	if (game!=5) {
		if (game==6) HighScoreSort(name, score); // enter
		if (game==7) KeysRemapExit(); // enter
		InfoTextClear ();
		InfoTextAlarm ();
		InfoTextRoll ();
		playsound('sfx/bonus.wav');
		game = 5;
		//PauseAll();
		GameStop ();
		//MainReset ();
		MainPicturesClear ();
		AlarmShow ();
	} else {
		//AlarmSave ();
		MainTime ();
	}
}

function MainTime () {
	if (game!=4) {
		if (game==6) HighScoreSort(name, score); // enter
		if (game==7) KeysRemapExit(); // enter
		playsound('sfx/bonus.wav');
		InfoTextClear ();
		InfoTextTime ();
		InfoTextRoll ();
		game = 4;
		//PauseAll();
		GameStop ();
		//MainReset ();
		MainPicturesClear ();
		TimeShow ();
	}
}

function MainReset () {
	if (game!=0) {
		if (game==6) HighScoreSort(name, score); // enter
		if (game==7) KeysRemapExit(); // enter
		playsound('sfx/bonus.wav');
		game = 0;
		//PauseAll();
		GameStop ();
		BarrelsReset ();
		SegmentsReset ();
		InfoTextClear ();
		MainPicturesShow ();
	}
}

function MainGameA() {
	if ((game!=1)&&(game!=2)) {
		if (game==6) HighScoreSort(name, score); // enter
		if (game==7) KeysRemapExit(); // enter
		playsound('sfx/bonus.wav');
		MainReset();
		InfoTextClear ();
		InfoTextIngame ();
		InfoTextRoll ();
		// variables reset
		game=1;
		kong = 2;
		kongThrow = false;
		bonus = 0;
		hold = 4;
		life = 3;
		score = 0;
		marioKill = false; // if mario was killed
		mario = 0;
		marioJump = false;
		hook = 0;
		// variables just for this type of game
		barrelsRandom=2; // random at init
		barrelsSpeed = 800;
		segmentsRandom = 10;
		segmentsSpeed = 2000;
		kongRandom = 10; //01 2 3
		kongSpeed = 300;
		hookSpeed = 440;
		hookSpeedMario = 600;
		marioSpeedJump = 800;
		marioSpeedFall = 500;
		marioSpeedKill = 200;
		marioTime = 10000; // time to go mario
		scoreSpeed = 40;
		loveSpeed = 80;
		// init all functions
		MainPicturesClear();
		MainPicturesGame(); 
		UnPauseAll ();
		ScoreShow ();
		BarrelsGo (); 
		SegmentsGo (); 
		AllInit ();
		KongGo ();
	}
}

function MainGameB() {
	if ((game!=1)&&(game!=2)) {
		if (game==6) HighScoreSort(name, score); // enter
		if (game==7) KeysRemapExit(); // enter
		playsound('sfx/bonus.wav');
		MainReset();
		InfoTextClear ();
		InfoTextIngame ();
		InfoTextRoll ();
		// variables reset
		game=2;
		kong = 2;
		kongThrow = false;
		bonus = 0;
		hold = 4;
		life = 3;
		score = 0;
		marioKill = false; // if mario was killed
		mario = 0;
		marioJump = false;
		hook = 0;
		// variables just for this type of game
		barrelsRandom=4; // random at init
		barrelsSpeed = 560;
		segmentsRandom = 8;
		segmentsSpeed = 1400;
		kongRandom = 8; //01 2 3
		kongSpeed = 210;
		hookSpeed = 308;
		hookSpeedMario = 420;
		marioSpeedJump = 560;
		marioSpeedFall = 350;
		marioSpeedKill = 140;
		marioTime = 7000; // time to go mario
		scoreSpeed = 28;
		loveSpeed = 56;
		// init all functions
		MainPicturesClear();
		MainPicturesGame(); 
		UnPauseAll ();
		ScoreShow ();
		BarrelsGo (); 
		SegmentsGo (); 
		AllInit ();
		KongGo ();
	}
}

function HighScoreEdit () {
	clearTimeout(infoID);
	InfoTextClear ();
	infoMsg='Enter your name:';
	document.Info.text.value = infoMsg;
	name='';
	codeCurrent=0;

	HighScoreEditGo();
}

function HighScoreEditGo () {
	var tmpCode=codeCurrent;

	if (tmpCode != 0) {
		if (tmpCode==13) 
			HighScoreSort(name, score); // enter
		else {
			if (name.length < 10) {
				var codeLetter = tmpCode-96; // now 1 is a
				if ( (codeLetter>0) && (codeLetter<27) ) name+=chars[codeLetter];
				if (tmpCode == 32) name+=" ";
			}
			if (tmpCode == 27) name=name.substring(0,name.length-1); // esc
			codeCurrent=0;
			infoMsg='Name: '+name;
			document.Info.text.value = infoMsg;

			nameID=setTimeout("HighScoreEditGo()", 200);
		}
	} else {
		if (name.length==0) {
			if (nameFlash) {
				nameFlash=false	
				infoMsg='';
			} else {
				nameFlash=true;
				infoMsg='Enter your name:';
			}
			document.Info.text.value = infoMsg;
		}
		nameID=setTimeout("HighScoreEditGo()", 200);
	}
}

function MainKeys () {
	if (game==6) HighScoreSort(name, score); // enter
	if (game==7) KeysRemapExit(); // enter
	if ((game==1)||(game==2)) 
		return;
	else {
		clearTimeout(infoID);
		InfoTextClear ();
		infoMsg='';
		document.Info.text.value = infoMsg;
		codeCurrent=0;
		game=7;
		keys=0;

		KeysRemap();
	}
}

function KeysRemap () {
	var tmpCode=codeCurrent;

	if (tmpCode != 0) {
		if (tmpCode==27) 
			KeysRemapExit (); // escape
		else {
			//var codeLetter = tmpCode-96; // now 1 is a
			//if ( (codeLetter>0) && (codeLetter<27) ) name+=chars[codeLetter];

			document.Info.text.value = infoMsg;

			if (keys==0) {
				codeUp=tmpCode; 
				keys++;
				keysID=setTimeout("KeysRemap()", 200);
			} else
			if (keys==1) {
				if (tmpCode!=codeUp) {
					codeDown=tmpCode; 
					keys++;
				}
				keysID=setTimeout("KeysRemap()", 200);
			} else
			if (keys==2) {
				if ((tmpCode!=codeUp)
					&&(tmpCode!=codeDown)) {
					codeLeft=tmpCode; 
					keys++;
				}
				keysID=setTimeout("KeysRemap()", 200);
			} else
			if (keys==3) {
				if ((tmpCode!=codeUp)
					&&(tmpCode!=codeDown)
					&&(tmpCode!=codeLeft)) {
					codeRight=tmpCode; 
					keys++;
				}
				keysID=setTimeout("KeysRemap()", 200);
			} else
			if (keys==4) {
				if ((tmpCode!=codeUp)
					&&(tmpCode!=codeDown)
					&&(tmpCode!=codeLeft)
					&&(tmpCode!=codeRight)) {
					codeJump=tmpCode; 
					keys++;
				}
				keysID=setTimeout("KeysRemap()", 200);
			} else
			if (keys==5) {
				if ((tmpCode!=codeUp)
					&&(tmpCode!=codeDown)
					&&(tmpCode!=codeLeft)
					&&(tmpCode!=codeRight)
					&&(tmpCode!=codeJump)) {
					codeGameA=tmpCode; 
					keys++;
				}
				keysID=setTimeout("KeysRemap()", 200);
			} else
			if (keys==6) {
				if ((tmpCode!=codeUp)
					&&(tmpCode!=codeDown)
					&&(tmpCode!=codeLeft)
					&&(tmpCode!=codeRight)
					&&(tmpCode!=codeJump)
					&&(tmpCode!=codeGameA)) {
					codeGameB=tmpCode; 
					keys++;
				}KeysRemapExit();
				//keysID=setTimeout("KeysRemap()", 200);
			}
			//else
			//if (keys==7) KeysRemapExit();

			codeCurrent=0;
		}
	} else {
		if (keysFlash) {
			keysFlash=false	
			infoMsg='';
		} else {
			keysFlash=true;
			if (keys==0) infoMsg='Press key for UP:';
			if (keys==1) infoMsg='Press key for DOWN:';
			if (keys==2) infoMsg='Press key for LEFT:';
			if (keys==3) infoMsg='Press key for RIGHT:';
			if (keys==4) infoMsg='Press key for JUMP:';
			if (keys==5) infoMsg='Press key for START A:';
			if (keys==6) infoMsg='Press key for START B:';		
		}

		document.Info.text.value = infoMsg;
		keysID=setTimeout("KeysRemap()", 200);
	}
}

function KeysRemapExit () {
	clearTimeout(keysID);
	game=3;
	InfoTextClear ();
	InfoTextKeys ();
	InfoTextHighScores ();
	InfoTextStart ();
	InfoTextIngame ();
	InfoTextRoll ();
	Info();
}

function KeyCode(code) {
	if ( (code-96>0) && (code-96<27) ) return chars[code-96];
	if ( (code>47) && (code<58)) return eval(code-48);
	if (code == 32) return 'space';
	return '';
}

function InfoTextKeys () {
	infoMsg+='                      ';
	infoMsg+='Keys mapped as follows...        ';
	infoMsg+='Up: ' + KeyCode(codeUp) + '        ';
	infoMsg+='Down: ' + KeyCode(codeDown) + '        ';
	infoMsg+='Left: ' + KeyCode(codeLeft) + '        ';
	infoMsg+='Right: ' + KeyCode(codeRight) + '        ';
	infoMsg+='Jump: ' + KeyCode(codeJump) + '        ';
	infoMsg+='Start A: ' + KeyCode(codeGameA) + '        ';
	infoMsg+='Start B: ' + KeyCode(codeGameB) + '        ';
}

// my score -> high score; I assume that I'm at least on last position
function HighScoreSort(hname, hscore) {
	clearTimeout(nameID);
	var tmp;
	if (hscore<10) var insert=hname+"...000"+eval(hscore);
	else if (hscore<100) var insert=hname+"...00"+eval(hscore);
	else if (hscore<1000) var insert=hname+"...0"+eval(hscore);
	else var insert=hname+"..."+eval(hscore);
	hi[9]=insert;

	for (i=9; i>1; i--)
		if (
		parseInt(hi[i].substring( hi[i].length-4, hi[i].length))
		>
		parseInt(hi[i-1].substring( hi[i-1].length-4, hi[i-1].length))
		) {
			tmp=hi[i];
			hi[i]=hi[i-1];
			hi[i-1]=tmp;
		}
	MainGameOver ();
	Info();
}

function Info () {
	if (game!=6){
		document.Info.text.value = infoMsg.substring(infoPos, infoPos+20);
		infoPos++;

		if ( infoPos==infoMsg.length-20 ) infoPos=0;
		infoID=setTimeout("Info()", 150);
	}
}

function InfoTextClear () {
	infoMsg='';
	infoPos=0;
}

function InfoTextRoll () {
	infoMsg+=infoMsg.substring(0, 20);
	infoPos=0;
}

function InfoTextHighScores () {
	infoMsg+='                      ';
	infoMsg+='High scores so far...';
	infoMsg+='                ';
	for ( i=1 ; i<10 ; i++ ) infoMsg += '#' +eval(i)+ '...' +hi[i]+ '        ';
	infoMsg+='        ';
}

function InfoTextStart () {
	infoMsg+='                      ';
	infoMsg+='Welcome to Donkey Kong HTML written by Andrzej Czyz. ';
	infoMsg+='Based on Game&Watch Multi Screen "Donkey Kong" Nintendo 1982. ';
	infoMsg+='        ';
	infoMsg+='Press A button for Game A mode, press B button for Game B mode, ';
	infoMsg+='press Time button for Time mode, ';
	infoMsg+='press Reset button to reset the game, press Alarm button to set the alarm, press Keys button to remap the control keys. ';
}

function InfoTextIngame () {
	infoMsg+='                      ';
	infoMsg+='Donkey Kong captured a beautiful girl and carries her into a building under construction. ';
	infoMsg+=' The brave carpenter, Mario comes to rescue her following them over the girders. ';
	infoMsg+='Donkey Kong throws barrels at Mario to stop him. ';
	infoMsg+='Knock the girder out from under Donkey Kong to save the girl. ';
}

function InfoTextAlarm () {
	infoMsg+='Press Up/Down to change alarm hour. ';
	infoMsg+='Press Left/Right to change alarm minute. ';
}

function InfoTextTime () {
	infoMsg+='                      ';
	infoMsg+='Alarm is set at '+eval(prefAlarmHour)+":"+eval(prefAlarmMin)+"";
	infoMsg+='        ';
}

function InfoTextLoading () {
	infoMsg+='Please wait while loading... You may continue, although there may be some graphics slowdowns. ';
}

function MainLoaded() {
	MainReset ();
	InfoTextClear ();
	InfoTextStart ();
	InfoTextKeys ();
	InfoTextHighScores ();
	InfoTextIngame ();
	InfoTextRoll ();
	loaded=true;
}

// this function is started when first loaded
function Loaded() {
	PrefsLoad ();
	InfoTextClear ();
	InfoTextLoading ();
	InfoTextRoll ();
	Info();
	PicPreload();
	TimeAlarmBackground ();
}

// this function is started when closed
function Closed() {
	PrefsSave ();
}
